''' Raspberry Pi Pico - Voltmeter
 Sends via uart
 Works with ADC pins 0 to 4 
 pins 0 to 2 are gp26 to gp28
 pin 4 is internal temp sensor
 See: www.penguintutor.com/projects/pico '''

from machine import UART, ADC

uart = UART(1,115200)

adc_pin = 0
adc_value = 0
adc = machine.ADC(adc_pin)

conversion_factor=3.3/65535;

while True:
    ch = uart.read(1)
    # convert read value (byte into a number for the pin)
    read_pin = int.from_bytes(ch, "little")
    if (read_pin >= ord('0') and read_pin <= ord('4')):
        new_pin = read_pin - ord('0')
        if (new_pin != adc_pin):
            # Select new pin
            adc_pin = new_pin 
            adc = machine.ADC(adc_pin)
        # Now read adc value
        adc_value = adc.read_u16()
        #print ("Pin {} value {}".format(adc_pin, adc_value * conversion_factor))
        uart.write ("Pin {} value {}\n".format(adc_pin, adc_value * conversion_factor))
    
